how to convert from C# code.where(...) to python in Revit API

709 Views Asked by At

I am trying to convert a C# code (for revit API) to python but to no luck. The C# code looks:

 public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
    {
        Document doc = commandData.Application.ActiveUIDocument.Document;

        Reference r = commandData.Application.ActiveUIDocument.Selection.PickObject(Autodesk.Revit.UI.Selection.ObjectType.Element, "please select wall");

        IEnumerable<Element> associate = new FilteredElementCollector(doc).OfClass(typeof(FamilyInstance)).Where(m=>(m as FamilyInstance).Host.Id  == r.ElementId);

        return Result.Succeeded;
    }

what I am having problem with is the part .Where(m=>(m as FamilyInstance).Host.Id == r.ElementId); I use pyrevit. can anyone suggest how to do it? thank you!

1

There are 1 best solutions below

0
On

You can conceivably convert C# code into python in places like csharp-to-python or using SharpDevelop Macro Editor.

The conversion will not run because certain classes are constructed differently in Python scripts

If you want to write what you have there in python first need some different declarations. Usings example:

import clr
clr.AddReference("RevitAPI")
from Autodesk.Revit.DB import *
clr.AddReference('RevitAPIUI')
from Autodesk.Revit.UI import *
clr.AddReference("RevitServices")
import RevitServices
from RevitServices.Persistence import DocumentManager
from RevitServices.Transactions import TransactionManager

Then Document & UIApp as an example need to be created using Document Manager:

app = DocumentManager.Instance.CurrentUIApplication
doc = DocumentManager.Instance.CurrentDBDocument

For Current Selection this article should do the trick

For the portion of the code you have a problem with:

IEnumerable<Element> associate = new FilteredElementCollector(doc).
OfClass(typeof(FamilyInstance)).
Where(m=>(m as FamilyInstance).Host.Id  == r.ElementId);

Remember you are using LINQ. For python (unless i'm mistaken) you would need something like this LINQ in Python.

For transactions usually:

TransactionManager.Instance.EnsureInTransaction(doc)  
  {Do Something}
TransactionManager.Instance.TransactionTaskDone()

Assemble the code and try to run it in RevitPythonShell.

Just remember you can use C# assemblies directly in PyRevit here is a link